import os
import requests
from bs4 import BeautifulSoup
from urllib.parse import urljoin, urlparse
from tqdm import tqdm 
 
def download_image(url, save_directory):
    try:
        response = requests.get(url, stream=True)
        response.raise_for_status()
 
        # URLȡļ
        filename = os.path.basename(urlparse(url).path)
        save_path = os.path.join(save_directory, filename)
 
        # ȡļСڽʾ
        file_size = int(response.headers.get("Content-Length", 0))
 
        with open(save_path, 'wb') as f, tqdm(
                desc=filename,
                total=file_size,
                unit='B',
                unit_scale=True,
                unit_divisor=1024,
        ) as progress_bar:
            for chunk in response.iter_content(chunk_size=8192):
                f.write(chunk)
                progress_bar.update(len(chunk))
 
        print(f": {filename}")
    except requests.exceptions.RequestException as e:
        print(f"ʧ: {url}: {e}")
 
def scrape_and_download_images(start_url, save_directory):
    try:
        response = requests.get(start_url)
        response.raise_for_status()
        soup = BeautifulSoup(response.content, 'html.parser')
 
        for img_tag in soup.find_all('img'):
            img_url = img_tag.get('src')
            if img_url:
                # ϲURLͻURLȡURL
                img_url = urljoin(start_url, img_url)
                download_image(img_url, save_directory)
 
    except requests.exceptions.RequestException as e:
        print(f"ʧ: {start_url}: {e}")
 
if __name__ == "__main__":
    start_url = input("ҪȡͼƬվַ")
    save_directory = input("뱣ͼƬĿ¼ĬΪimagesļУ") or "images"
 
    if not os.path.exists(save_directory):
        os.makedirs(save_directory)
 
    scrape_and_download_images(start_url, save_directory)
